weipa::ElementData Class Referenceabstract

Stores and manipulates one type of domain elements. More...

`#include <ElementData.h>`

Inheritance diagram for weipa::ElementData:

## Public Member Functions

virtual void | writeConnectivityVTK (std::ostream &os)=0
| Writes connectivity data to a stream in VTK text format. More...
virtual StringVec | getMeshNames () const =0
| Returns the names of the meshes associated with the elements. More...
virtual StringVec | getVarNames () const =0
| Returns a vector with the mesh variable names. More...
virtual int | getNumElements () const =0
| Returns the number of elements. More...
virtual int | getNodesPerElement () const =0
| Returns the number of nodes per element. More...
virtual int | getGhostCount () const =0
| Returns the number of "ghost" elements. More...
virtual ZoneType | getType () const =0
| Returns the element type. More...
virtual const IntVec & | getNodeList () const =0
| Returns a vector of the node IDs used by the elements. More...
virtual const IntVec & | getIDs () const =0
| Returns a vector of element IDs. More...
virtual NodeData_ptr | getNodes () const =0
| Returns the NodeData instance used by the elements. More...
virtual ElementData_ptr | getReducedElements () const =0
| Returns the reduced elements if available. More...
virtual const QuadMaskInfo & | getQuadMask (int fsCode) const =0
| Returns a QuadMaskInfo structure for given functionspace code. More...
virtual int | getElementFactor () const =0
| If the original element type is not supported they are subdivided into N smaller elements (e.g. one Rec9 -> four Rec4) and this method returns the multiplication factor N. More...

## Protected Member Functions

virtual | ~ElementData ()

## Detailed Description

Stores and manipulates one type of domain elements.

Note
  The corresponding mesh nodes are not part of this class but are stored in a NodeData instance.

## Constructor & Destructor Documentation

## ~ElementData()

virtual weipa::ElementData::~ElementData | ( |  | ) |

inline protected virtual

## Member Function Documentation

## getElementFactor()

virtual int weipa::ElementData::getElementFactor | ( |  | ) | const

pure virtual

If the original element type is not supported they are subdivided into N smaller elements (e.g. one Rec9 -> four Rec4) and this method returns the multiplication factor N.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getGhostCount()

virtual int weipa::ElementData::getGhostCount | ( |  | ) | const

pure virtual

Returns the number of "ghost" elements.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getIDs()

virtual const IntVec& weipa::ElementData::getIDs | ( |  | ) | const

pure virtual

Returns a vector of element IDs.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getMeshNames()

virtual StringVec weipa::ElementData::getMeshNames | ( |  | ) | const

pure virtual

Returns the names of the meshes associated with the elements.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getNodeList()

virtual const IntVec& weipa::ElementData::getNodeList | ( |  | ) | const

pure virtual

Returns a vector of the node IDs used by the elements.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getNodes()

virtual NodeData_ptr weipa::ElementData::getNodes | ( |  | ) | const

pure virtual

Returns the NodeData instance used by the elements.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getNodesPerElement()

virtual int weipa::ElementData::getNodesPerElement | ( |  | ) | const

pure virtual

Returns the number of nodes per element.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getNumElements()

virtual int weipa::ElementData::getNumElements | ( |  | ) | const

pure virtual

Returns the number of elements.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getQuadMask()

virtual const QuadMaskInfo& weipa::ElementData::getQuadMask | ( | int | fsCode | ) | const

pure virtual

Returns a QuadMaskInfo structure for given functionspace code.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getReducedElements()

virtual ElementData_ptr weipa::ElementData::getReducedElements | ( |  | ) | const

pure virtual

Returns the reduced elements if available.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getType()

virtual ZoneType weipa::ElementData::getType | ( |  | ) | const

pure virtual

Returns the element type.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## getVarNames()

virtual StringVec weipa::ElementData::getVarNames | ( |  | ) | const

pure virtual

Returns a vector with the mesh variable names.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

## writeConnectivityVTK()

virtual void weipa::ElementData::writeConnectivityVTK | ( | std::ostream & | os | ) |

pure virtual

Writes connectivity data to a stream in VTK text format.

Implemented in weipa::SpeckleyElements, weipa::RipleyElements, and weipa::FinleyElements.

The documentation for this class was generated from the following file:

- ElementData.h